package com.landray.kmss.sys.attachment.service.spring;

import com.landray.kmss.common.model.IBaseModel;
import com.landray.kmss.sys.attachment.model.SysAttDownloadLog;
import org.hibernate.Query;
import com.landray.kmss.common.dao.HQLInfo;
import com.landray.kmss.sys.attachment.model.SysAttBase;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.common.actions.RequestContext;
import java.util.List;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import com.landray.kmss.sys.attachment.service.ISysAttDownloadLogService;
import com.landray.kmss.common.service.BaseServiceImp;

public class SysAttDownloadLogServiceImp extends BaseServiceImp implements ISysAttDownloadLogService
{
    private ISysAttMainCoreInnerService sysAttMainService;
    private String downloadFlag;
    
    public SysAttDownloadLogServiceImp() {
        this.downloadFlag = "";
    }
    
    public ISysAttMainCoreInnerService getSysAttMainCoreService() {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
    
    public void addDownloadLogByAttList(final List<?> atts, final RequestContext context) throws Exception {
        final String downloadType = context.getParameter("downloadType");
        if (StringUtil.isNull(downloadType) || !downloadType.equals("manual")) {
            return;
        }
        final String flag = context.getParameter("downloadFlag");
        if (StringUtil.isNull(flag) || !flag.equals(this.downloadFlag)) {
            for (int i = 0; i < atts.size(); ++i) {
                final SysAttMain att = (SysAttMain)atts.get(i);
                this.addDownloadLogByAtt((SysAttBase)att, context);
            }
            this.downloadFlag = flag;
        }
    }
    
    public Long getDownloadCount(final String fdModelName, final String fdModelId) throws Exception {
        final HQLInfo hqlInfo = new HQLInfo();
        hqlInfo.setSelectBlock(" count(*) ");
        hqlInfo.setWhereBlock("sysAttDownloadLog.fdModelName = :fdModelName and sysAttDownloadLog.fdModelId = :fdModelId");
        this.includeRecord(hqlInfo);
        hqlInfo.setParameter("fdModelName", (Object)fdModelName);
        hqlInfo.setParameter("fdModelId", (Object)fdModelId);
        final List<?> list = this.findValue(hqlInfo);
        return (Long)list.get(0);
    }
    
    public void includeRecord(final HQLInfo hqlInfo) {
        String whereBlock = hqlInfo.getWhereBlock();
        whereBlock = StringUtil.linkString(whereBlock, " and ", "sysAttDownloadLog.fdDownloadType = :fdDownloadType");
        hqlInfo.setWhereBlock(whereBlock);
        hqlInfo.setParameter("fdDownloadType", (Object)"manual");
    }
    
    public void deleteByAttId(final String attId) throws Exception {
        final String sql = "delete from sys_att_download_log where fd_att_id =:attId";
        final Query query = (Query)this.getBaseDao().getHibernateSession().createSQLQuery(sql);
        query.setString("attId", attId);
        query.executeUpdate();
    }
    
    public void addDownloadLogByAtt(final SysAttBase att, final RequestContext context) throws Exception {
        final String downloadType = context.getParameter("downloadType");
        if (StringUtil.isNull(downloadType) || !downloadType.equals("manual") || StringUtil.isNull(att.getFdModelId())) {
            return;
        }
        this.getSysAttMainCoreService().addDownloadCount(att.getFdId());
        final SysAttDownloadLog log = new SysAttDownloadLog();
        log.setFdAttId(att.getFdId());
        log.setFdFileName(att.getFdFileName());
        log.setFdModelId(att.getFdModelId());
        log.setFdModelName(att.getFdModelName());
        log.setFdKey(att.getFdKey());
        log.setFdIp(context.getRemoteAddr());
        log.setFdDownloadType(downloadType);
        this.getBaseDao().add((IBaseModel)log);
    }
}
